(* Release 3.10 *)(*fix*)(* For CW5 *)
(*-------------------------------------------------------------------------*
*                                                                          *
*  IO.MOD - Terminal input/output                                          *
*                                                                          *
*  COPYRIGHT (C) 1987..1992 Clarion Software Corporation.                  *
*  All Rights Reserved                                                     *
*                                                                          *
*  Modified for Topspeed Clarion V5.0   CWS    03-02-01                    *
*  Change 'LONGCARD(Var)' to the form 'VAL(LONCARD, Var)'.  CWS  08-17-01  *
*  Change 'REAL(Var)' to the form 'VAL(REAL, Var)'.         CWS  08-17-01  *
*                                                                          *
*--------------------------------------------------------------------------*)

(*# call(o_a_copy => off) *)
(*   # check(stack=>off,
          index=>off,
          range=>off,
          overflow=>off,
          nil_ptr=>off) *)

IMPLEMENTATION MODULE IO;

IMPORT Lib, Str, CWRUN;


(*%T UseAlertfunctions *)                             (* 04-28-99 *)
IMPORT CDOSCALL;                                      (* 04-28-99 *)
(*%E*)




CONST
   nul = CHAR(0);
   cr = CHAR(0DH);
   lf = CHAR(0AH);
   bs = CHAR(08H);
   esc = CHAR(1BH);
   crlf = cr + lf + nul;


CONST
  TrueStr = 'TRUE';
  ConStr  = 'CON';

VAR
  VIOoutput : BOOLEAN;
  LWW     : BOOLEAN;
  Buffer  : ARRAY[0..MaxRdLength-1] OF CHAR;
  s,e     : CARDINAL;

TYPE
  Str80   = ARRAY[0..79] OF CHAR;
  PathStr = Str80;

VAR
  AlertFkey: CHAR;                                (* 06-09-99 *)


CONST
(* Clarion key codes from 'keycodes.clw' *)
    F1Key     = 0070H;
    F2Key     = 0071H;
    F3Key     = 0072H;
    F4Key     = 0073H;
    F5Key     = 0074H;
    F6Key     = 0075H;
    F7Key     = 0076H;
    F8Key     = 0077H;
    F9Key     = 0078H;
    F10Key    = 0079H;
    F11Key    = 007AH;
    F12Key    = 007BH;
    AltF1     = 0470H;
    AltF2     = 0471H;
    AltF3     = 0472H;
    AltF4     = 0473H;
    AltF5     = 0474H;
    AltF6     = 0475H;
    AltF7     = 0476H;
    AltF8     = 0477H;
    AltF9     = 0478H;
    AltF10    = 0479H;
    AltF11    = 047AH;
    AltF12    = 047BH;
    HomeKey   = 0024H;
    EndKey    = 0023H;
    PgUpKey   = 0021H;
    PgDnKey   = 0022H;
    UpKey     = 0026H;
    DownKey   = 0028H;
    CtrlC     = 0243H;                        (* 03-02-01 *)
    CtrlR     = 0252H;                        (* 03-02-01 *)
    CtrlX     = 0258H;                        (* 03-02-01 *)





(*%T UseAlertfunctions *)                             (* 04-28-99 *)
PROCEDURE AlertKeyPressed (): BOOLEAN;
BEGIN
  RETURN ( AlertKeyCode # CARDINAL(0) ) OR (AlertFkey # CHAR(0));  (* 06-09-99 *)
END AlertKeyPressed;
(*%E*)



(*%T UseAlertfunctions *)                             (* 04-28-99 *)
PROCEDURE AlertRdKey() : CHAR;
VAR
  chr: CHAR;
BEGIN
  WHILE NOT AlertKeyPressed() DO                      (* 04-30-99 *)
    CDOSCALL.PDELAY(0);                               (* 04-30-99 *)
   (* CDOSCALL.WAITKEY(); *)                               (* 08-05-00 *)
  END; (* while *)
  IF AlertFkey # CHAR(0) THEN                         (* 06-09-99 *)
    chr := AlertFkey;                                 (* 06-09-99 *)
    AlertFkey := CHAR(0);
  ELSE
    chr := VAL(CHAR, AlertKeyChar);                   (* 06-09-99 *)
    IF chr = CHAR(0) THEN                             (* 06-09-99 *)
      CASE AlertKeyCode OF
      | F1Key: AlertFkey := ";";
      | F2Key: AlertFkey := "<";
      | F3Key: AlertFkey := "=";
      | F4Key: AlertFkey := ">";
      | F5Key: AlertFkey := "?";
      | F6Key: AlertFkey := "@";
      | F7Key: AlertFkey := "A";
      | F8Key: AlertFkey := "B";
      | F9Key: AlertFkey := "C";
      | F10Key: AlertFkey := "D";
      | F11Key: AlertFkey := CHAR(85H);
      | F12Key: AlertFkey := CHAR(86H);
      | AltF1: AlertFkey := "h";
      | AltF2: AlertFkey := "i";
      | AltF3: AlertFkey := "j";
      | AltF4: AlertFkey := "k";
      | AltF5: AlertFkey := "l";
      | AltF6: AlertFkey := "m";
      | AltF7: AlertFkey := "n";
      | AltF8: AlertFkey := "o";
      | AltF9: AlertFkey := "p";
      | AltF10: AlertFkey := "q";
      | AltF11: AlertFkey := CHAR(8BH);
      | AltF12: AlertFkey := CHAR(8CH);
      | HomeKey: AlertFkey := "G";
      | EndKey:  AlertFkey := "O";
      | PgUpKey: AlertFkey := "I";
      | PgDnKey: AlertFkey := "Q";
      | UpKey:   AlertFkey := "H";
      | DownKey: AlertFkey := "P";
      | CtrlC:   AlertFkey := " "; chr := CHAR(03H);     (* 03-02-01 *)
      | CtrlR:   AlertFkey := " "; chr := CHAR(12H);     (* 03-02-01 *)
      | CtrlX:   AlertFkey := " "; chr := CHAR(18H);     (* 03-02-01 *)
      ELSE AlertFkey := " ";
      END; (* case *)
    END;
    AlertKeyCode := WORD(0);
  END;
  RETURN chr;
END AlertRdKey;
(*%E*)



PROCEDURE KeyPressed (): BOOLEAN;
BEGIN
(*%T UseAlertfunctions *)                             (* 04-28-99 *)
    RETURN AlertKeyPressed();
(*%E*)
(*%F UseAlertfunctions *)                             (* 04-28-99 *)
    RETURN ( CWRUN.KEYBOARD() # 0 )         
(*%E*)
END KeyPressed;




PROCEDURE TerminalRdStr(VAR Wstr: ARRAY OF CHAR);       (* 03-23-99 *)
CONST EchoChrs = TRUE;                      (* 03-23-99 *)
VAR Slen, Sptr, Vptr: CARDINAL;  wchr: CHAR;  EndHit: BOOLEAN;  (* 01-13-96 *)

  PROCEDURE IncrChar(VAR Ps:CARDINAL);              (* 01-19-96 *)
  BEGIN
    IF Ps > Slen THEN Ps := Slen+1; RETURN; END;
    INC(Ps);
  END IncrChar;

BEGIN   (* TerminalRdStr *)
  IF Prompt AND NOT LWW THEN WrStr('?'); END;
  LWW := FALSE;
   Slen := HIGH(Wstr)+1;                    (* 03-23-99 *)
  EndHit := FALSE;                      (* 06-02-95 *)
  Sptr := 0;                            (* 01-23-96 *)
  IncrChar(Sptr);                       (* 01-20-96 *)
  LOOP
    IF Sptr > Slen THEN EXIT; END;              (* 03-23-99 *)
    wchr := RdKey();                     (* 04-30-99 *)
    CASE wchr OF
     | nul:
     | bs:
      IF Sptr > 1 THEN
        Vptr := Sptr;                   (* 01-19-96 *)
        DEC(Sptr);                      (* 06-02-95 *)
      END; (* if *)
     | cr: EXIT;
     | esc: wchr := nul; EXIT;                  (* 09-06-95 *)
    ELSE
      IF Sptr <= Slen THEN                  (* 05-18-95 *)
       Wstr[Sptr-1] := wchr;                (* 06-02-95 *)
       IF EchoChrs THEN IO.WrChar(wchr);            (* 01-23-96 *)
       ELSE IO.WrChar("*"); END;                (* 01-23-96 *)
       IF Sptr = Slen THEN  (* end of field *)      (* 06-02-95 *)
         INC(Sptr); EXIT;                   (* 03-23-99 *)
       END;
       IncrChar(Sptr);                  (* 01-20-96 *)
      END;
    END; (* case *)
    IF Sptr > HIGH(Wstr) THEN WrLn(); RETURN; END;        (* 05-03-00 *)
  END; (* loop *)
  Wstr[Sptr-1] := nul;                   (* 05-17-95 *)
  WrLn();                                (* 05-03-00 *)
END TerminalRdStr;



PROCEDURE GetName(name: ARRAY OF CHAR; VAR fn: PathStr);
(* Makes Null terminated filename, also sets IOR to 0 *)
BEGIN
  Str.Copy(fn,name);
  fn[HIGH(fn)] := CHR(0);
END GetName;



PROCEDURE WrStr(s: ARRAY OF CHAR);
BEGIN
  WrStrRedirect(s);
END WrStr;


PROCEDURE RdStr ( VAR s : ARRAY OF CHAR );
BEGIN
  RdStrRedirect(s);
END RdStr;


PROCEDURE RdBuff();
VAR
  p,h : CARDINAL;
BEGIN
  RdStrRedirect(Buffer);
  p := Str.Length(Buffer);
  h := SIZE(Buffer)-1;
  IF p>h-1 THEN p := h-1; END;
  Buffer[p] := CHR(13); INC(p);
  Buffer[p] := CHR(10); INC(p);
  IF p<=h THEN Buffer[p] := CHR(0) END;
  e := p; s := 0;
END RdBuff;


PROCEDURE TerminalWrStr(string: ARRAY OF CHAR);
BEGIN
  LWW := TRUE;
  M2SCROLL.WrStr(DFW,string,FALSE,FALSE);                    (* 05-12-99 *)
END TerminalWrStr;


PROCEDURE RdKey() : CHAR;
BEGIN
(*%T UseAlertfunctions *)                             (* 04-28-99 *)
  RETURN AlertRdKey();                                (* 04-28-99 *)
(*%E*)
(*%F UseAlertfunctions *)                             (* 04-28-99 *)
  CWRUN.ASK;                      (* 03-23-99 *)
  RETURN VAL(CHAR, CWRUN.KEYCHAR() );         (* 03-23-99 *)
(*%E*)
END RdKey;


(*# save,
    call(o_a_copy => on) *)

PROCEDURE WrStrAdj( S : ARRAY OF CHAR; Length : INTEGER );
VAR
  L : CARDINAL;
  a : INTEGER;
BEGIN
  OK := TRUE;
  IF RdLnOnWr  THEN RdLn(); END;
  L := Str.Length( S );
  a := ABS( Length ) - INTEGER( L );
  IF (a < 0) AND ChopOff THEN
    L := CARDINAL(ABS(Length));
    IF L<=HIGH(S) THEN S[L] := CHR(0); END;
    WHILE (L>0) DO DEC(L); S[L] := '?'; END;
    OK := FALSE;
    a  := 0;
  END;
  IF (Length > 0) AND (a > 0) THEN WrCharRep( PrefixChar,a ); END;
  WrStr( S );
  IF (Length < 0) AND (a > 0) THEN WrCharRep( SuffixChar,a ); END;
END WrStrAdj;
(*# restore *)


PROCEDURE WrChar( V: CHAR );
BEGIN
  IF RdLnOnWr THEN RdLn(); END;                           (* 05-03-00 *)
  WrStr( V );
END WrChar;

PROCEDURE WrCharRep(V: CHAR; count: CARDINAL);
VAR
  s   : Str80;
  i,j : CARDINAL;
BEGIN
  IF RdLnOnWr THEN RdLn(); END;                           (* 05-03-00 *)
  WHILE count>0 DO
    i := SIZE(s)-2;
    IF i>count THEN i := count END;
    DEC(count,i);
    j := 0;
    WHILE (j<i) DO s[j] := V; INC(j) END;
    s[j] := CHR(0);
    WrStr(s);
  END;
END WrCharRep;

PROCEDURE WrBool(V: BOOLEAN; Length: INTEGER);
BEGIN
  IF V THEN
    WrStrAdj(TrueStr,Length);
  ELSE
    WrStrAdj('FALSE',Length);
  END;
END WrBool;

PROCEDURE WrShtInt(V: SHORTINT; Length: INTEGER);
VAR
  S : Str80;
  b : BOOLEAN;
BEGIN
  Str.IntToStr( LONGINT(V),S,10,b);
  IF b THEN
    WrStrAdj(S,Length );
  END;
  OK := b;
END WrShtInt;

PROCEDURE WrInt(V: INTEGER; Length: INTEGER);
VAR
  S : Str80;
  b : BOOLEAN;
BEGIN
  Str.IntToStr( LONGINT(V),S,10,b);
  IF b THEN
    WrStrAdj(S,Length );
  END;
  OK := b;
END WrInt;

PROCEDURE WrLngInt(V: LONGINT; Length: INTEGER);
VAR
  S : Str80;
  b : BOOLEAN;
BEGIN
  Str.IntToStr( V,S,10,b);
  IF b THEN
    WrStrAdj(S,Length );
  END;
  OK := b;
END WrLngInt;

PROCEDURE WrShtCard(V: SHORTCARD; Length: INTEGER);
VAR S : Str80;
  b : BOOLEAN;
BEGIN
  Str.CardToStr(VAL(LONGCARD, V),S,10,b);            (* 08-17-01 *)
  IF b THEN
    WrStrAdj(S,Length );
  END;
  OK := b;
END WrShtCard;

PROCEDURE WrCard(V: CARDINAL; Length: INTEGER);
VAR
  S : Str80;
  b : BOOLEAN;
BEGIN
  Str.CardToStr(VAL(LONGCARD, V),S,10,b);            (* 08-17-01 *)
  IF b THEN
    WrStrAdj(S,Length );
  END;
  OK := b;
END WrCard;

PROCEDURE WrLngCard(V: LONGCARD; Length: INTEGER);
VAR
  S : Str80;
  b : BOOLEAN;
BEGIN
  Str.CardToStr(V,S,10,b);
  IF b THEN
    WrStrAdj(S,Length );
  END;
  OK := b;
END WrLngCard;

PROCEDURE WrShtHex(V: SHORTCARD; Length: INTEGER);
VAR
  S : Str80;
  b : BOOLEAN;
BEGIN
  Str.CardToStr(VAL(LONGCARD, V),S,16,b);            (* 08-17-01 *)
  IF b THEN
    WrStrAdj(S,Length );
  END;
  OK := b;
END WrShtHex;

PROCEDURE WrHex(V: CARDINAL; Length: INTEGER);
VAR
  S : Str80;
  b : BOOLEAN;
BEGIN
  Str.CardToStr(VAL(LONGCARD, V),S,16,b);            (* 08-17-01 *)
  IF b THEN
    WrStrAdj(S,Length );
  END;
  OK := b;
END WrHex;

PROCEDURE WrLngHex(V: LONGCARD; Length: INTEGER);
VAR S : Str80;
  b : BOOLEAN;
BEGIN
  Str.CardToStr(V,S,16,b);
  IF b THEN
    WrStrAdj(S,Length );
  END;
  OK := b;
END WrLngHex;

PROCEDURE WrReal(V: REAL; Precision: CARDINAL; Length: INTEGER);
VAR
  S : Str80;
  b : BOOLEAN;
BEGIN
  Str.RealToStr( VAL(LONGREAL, V),Precision,Eng,S,b);   (* 08-17-01 *)
  IF b THEN
    WrStrAdj(S,Length );
  END;
  OK := b;
END WrReal;

PROCEDURE WrFixReal(V: REAL; Precision: CARDINAL; Length: INTEGER);
VAR
  S : Str80;
  b : BOOLEAN;
BEGIN
  Str.FixRealToStr( VAL(LONGREAL, V),Precision,S,b );   (* 08-17-01 *)
  IF b THEN
    WrStrAdj(S,Length );
  END;
  OK := b;
END WrFixReal;

PROCEDURE WrLngReal(V : LONGREAL; Precision: CARDINAL; Length: INTEGER);
VAR
  S : Str80;
  b : BOOLEAN;
BEGIN
  Str.RealToStr( V,Precision,Eng,S,b);
  IF b THEN
    WrStrAdj(S,Length );
  END;
  OK := b;
END WrLngReal;

PROCEDURE WrFixLngReal(V: LONGREAL; Precision: CARDINAL; Length: INTEGER);
VAR
  S : Str80;
  b : BOOLEAN;
BEGIN
  Str.FixRealToStr(V,Precision,S,b );
  IF b THEN
    WrStrAdj(S,Length );
  END;
  OK := b;
END WrFixLngReal;


PROCEDURE WrLn();
BEGIN
  IF RdLnOnWr THEN RdLn(); END;                      (* 05-03-00 *)
  WrStr( crlf );
  LWW := FALSE;
END WrLn;


PROCEDURE RdBool() : BOOLEAN;
VAR s : Str80;
BEGIN
  RdItem( s );
  RETURN Str.Compare( s,TrueStr )=0;
END RdBool;

PROCEDURE RdShtInt() : SHORTINT;
VAR
  S : Str80;
  i : LONGINT;
  b : BOOLEAN;
BEGIN
  RdItem(S );
  i  := Str.StrToInt( S,10,b );
  OK := b AND (i >= -80H) AND (i < 80H);
  RETURN SHORTINT( i );
END RdShtInt;

PROCEDURE RdInt() : INTEGER;
VAR
  S : Str80;
  i : LONGINT;
  b : BOOLEAN;
BEGIN
  RdItem(S);
  i  := Str.StrToInt( S,10,b );
  OK := b AND (i >= -8000H) AND (i < 8000H);
  RETURN INTEGER(i);
END RdInt;

PROCEDURE RdLngInt() : LONGINT;
VAR
  S : Str80;
  i : LONGINT;
  b : BOOLEAN;
BEGIN
  RdItem(S);
  i  := Str.StrToInt( S,10,b );
  OK := b;
  RETURN i;
END RdLngInt;

PROCEDURE RdShtCard() : SHORTCARD;
VAR
  S : Str80;
  i : LONGCARD;
  b : BOOLEAN;
BEGIN
  RdItem(S);
  i  := Str.StrToCard( S,10,b );
  OK := b AND (i < 100H);
  RETURN SHORTCARD( i );
END RdShtCard;

PROCEDURE RdShtHex() : SHORTCARD;
VAR
  S : Str80;
  i : LONGCARD;
  b : BOOLEAN;
BEGIN
  RdItem(S);
  i  := Str.StrToCard( S,16,b );
  OK := b AND (i < 100H);
  RETURN SHORTCARD( i );
END RdShtHex;

PROCEDURE RdCard() : CARDINAL;
VAR
  S : Str80;
  i : LONGCARD;
  b : BOOLEAN;
BEGIN
  RdItem(S);
  i  := Str.StrToCard( S,10,b );
  OK := b AND (i < 10000H);
  RETURN CARDINAL( i );
END RdCard;

PROCEDURE RdHex() : CARDINAL;
VAR
  S : Str80;
  i : LONGCARD;
  b : BOOLEAN;
BEGIN
  RdItem(S);
  i  := Str.StrToCard( S,16,b );
  OK := b AND (i < 10000H);
  RETURN CARDINAL( i );
END RdHex;

PROCEDURE RdLngCard() : LONGCARD;
VAR
  S : Str80;
  i : LONGCARD;
  b : BOOLEAN;
BEGIN
  RdItem(S);
  i  := Str.StrToCard( S,10,b );
  OK := b;
  RETURN i;
END RdLngCard;

PROCEDURE RdLngHex() : LONGCARD;
VAR
  S : Str80;
  i : LONGCARD;
  b : BOOLEAN;
BEGIN
  RdItem(S);
  i  := Str.StrToCard( S,16,b );
  OK := b;
  RETURN i;
END RdLngHex;

PROCEDURE RdReal() : REAL;
VAR
  S   : Str80;
  r   : LONGREAL;
  b : BOOLEAN;
BEGIN
  RdItem(S );
  r  := Str.StrToReal( S,b);
  OK := b AND (ABS(r) <= 3.4E38 );
  RETURN VAL(REAL, r);                      (* 08-17-01 *)
END RdReal;

PROCEDURE RdLngReal() : LONGREAL;
VAR
  S : Str80;
  r : LONGREAL;
  b : BOOLEAN;
BEGIN
  RdItem(S);
  r  := Str.StrToReal( S,b);
  OK := b;
  RETURN r;
END RdLngReal;


PROCEDURE RdLn();
BEGIN
  s:=e;
END RdLn;

PROCEDURE EndOfRd(Skip: BOOLEAN) : BOOLEAN;
BEGIN
  IF Skip THEN
     WHILE (s < e) AND (Buffer[s] IN Separators) DO INC(s) END;
  END;
  RETURN s = e;
END EndOfRd;

PROCEDURE RdItem(VAR V: ARRAY OF CHAR);
VAR L,i : CARDINAL;
BEGIN
  OK := TRUE;
  L := HIGH(V);
  REPEAT
    IF s=e THEN RdBuff(); END;
    WHILE (s<e) AND ( Buffer[s] IN Separators ) DO INC(s); END;
    i := 0;
    WHILE (s<e) AND (i<=L) AND NOT ( Buffer[s] IN Separators )  DO
      V[i] := Buffer[s];
      INC(s);
      INC(i);
    END;
    IF i <= L THEN V[i] := CHR(0); END;
  UNTIL V[0] # CHR(0);
END RdItem;

PROCEDURE RdChar() : CHAR;
VAR
  c : CHAR;
  t : BOOLEAN;
BEGIN
  IF s >= e THEN RdBuff(); END;
  INC (s);
  RETURN Buffer[s-1];
END RdChar;

PROCEDURE RedirectInput(FileName: ARRAY OF CHAR);
VAR c : CARDINAL;
    fn: PathStr;
BEGIN
  GetName(FileName,fn);
 (* close file *)                       (* 03-23-99 *)
 (* open for read *)
 (* InputRedirected := (Str.Compare(fn,ConStr) # 0); *)
  InputRedirected := FALSE;
END RedirectInput;

PROCEDURE RedirectOutput(FileName: ARRAY OF CHAR);
VAR c : CARDINAL;
    fn: PathStr;
BEGIN
  GetName(FileName,fn);
   (* close file *)                     (* 03-23-99 *)
   (* Create *)
 (* OutputRedirected := (Str.Compare(fn,ConStr) # 0); *)
  OutputRedirected := FALSE;
END RedirectOutput;



BEGIN (* Init *)
  Prompt        := TRUE;
  RdLnOnWr      := FALSE;
  WrStrRedirect := TerminalWrStr;
  RdStrRedirect := TerminalRdStr;
  s             := e;
  OK            := TRUE;
  ChopOff       := FALSE;
  Separators    := CHARSET{CHR(9),CHR(10),CHR(13),CHR(26),' '};
  Eng           := FALSE;
  LWW           := FALSE;
  InputRedirected := FALSE;
  OutputRedirected := FALSE;
  PrefixChar    := ' ';
  SuffixChar    := ' ';
  AlertKeyCode := WORD(0);                        (* 04-12-99 *)
  AlertKeyChar := WORD(0);                        (* 06-09-99 *)
  AlertFkey := CHAR(0);                           (* 06-09-99 *)
  M2SCROLL.Open(DFW,0,0, M2SCROLL.ScreenWidth-1,M2SCROLL.ScreenDepth-1);

END IO.
